<?php
jimport('joomla.plugin.plugin');
class plgSystemCustom_quantity_weight extends JPlugin{
	function plgSystemCustom_quantity_weight(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('system', 'custom_quantity_weight');
			if(version_compare(JVERSION,'2.5','<')){
				jimport('joomla.html.parameter');
				$this->params = new JParameter($plugin->params);
			} else {
				$this->params = new JRegistry($plugin->params);
			}
		}
		JRequest::setVar('weight_params', $this->params);
	}
}

if(!function_exists('hikashop_product_price_for_quantity_in_cart') && !function_exists('hikashop_product_price_for_quantity_in_order')) {
	function hikashop_product_price_for_quantity_in_cart(&$product){
		$currencyClass = hikashop_get('class.currency');
		$quantity = @$product->cart_product_quantity;
		$params=JRequest::getVar("weight_params");
		$weight_field = $params->get('weight_field','');
		if(!empty($weight_field)){
			$quantity = $quantity*$product->$weight_field;
		}elseif (!empty($product->ordered_weight)){
			$quantity = $quantity*$product->ordered_weight;
		}
		$currencyClass->quantityPrices($product->prices,$quantity,$product->cart_product_total_quantity);
	}

	function hikashop_product_price_for_quantity_in_order(&$product){
		$quantity = $product->order_product_quantity;
		$params=JRequest::getVar("weight_params");
		$weight_field = $params->get('weight_field','');
		if(!empty($weight_field)){
			$quantity = $quantity*$product->$weight_field;
		}elseif(!empty($product->ordered_weight)){
			$quantity = $quantity*$product->ordered_weight;
		}
		$product->order_product_total_price_no_vat = $product->order_product_price*$quantity;
		$product->order_product_total_price = ($product->order_product_price+$product->order_product_tax)*$quantity;
	}
}